unit bkPageControl;

{$MODE Delphi}

{$R-}

interface

uses Messages, Windows, SysUtils, CommCtrl, Classes,
     Controls, Forms, Menus, Graphics, StdCtrls, RichEdit,
     ToolWin, ImgList, ExtCtrls, ComCtrls, {DsgnIntf,} Buttons,
     Dialogs, Grids, types;

type
 TbkPageControl = class;
 TbkTabSheet = class(TTabSheet)
  public
    PnTop: TPanel;
    LblProcessValue: TLabel;
    LblProcessName: TLabel;
    LblProcessUnits: TLabel;
    SgParams: TStringGrid;
    PageControl: TbkPageControl;
    constructor Create(TheOwner: TComponent); override;
  end;

  TbkPageControl = class(TCustomNotebook)
  protected
    procedure DoAddDockClient(Client: TControl; const ARect: TRect); override;
  public
    constructor Create(TheOwner: TComponent); override;
  end;

implementation

{$R *.res}

uses {ComStrs,} stypes;

{ TbkTabSheet }

constructor TbkTabSheet.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  PnTop := TPanel.Create(Self);
  with PnTop do
   begin
     Parent := Self;
     Caption := '';
     Align := alTop
   end;
  LblProcessValue := TLabel.Create(Self);
  with LblProcessValue do
    begin
      Parent:=PnTop;
      Caption := '';
      Top := 14;
      Left := 182;
    end;
  LblProcessName := TLabel.Create(Self) ;
  with LblProcessName do
    begin
      Parent := PnTop;
      Caption := '';
      Top := 14;
      Left := 80;
    end;
  LblProcessUnits := TLabel.Create(Self) ;
  with LblProcessUnits do
    begin
      Parent := PnTop;
      Caption := '';
      Top := 14;
      Left := 310;
    end;
  SgParams := TStringGrid.Create(Self) ;
  with SgParams do
    begin
      Parent := Self;
      Align := AlClient;
      Height := font.height;
      ColCount := 4;
      DefaultColWidth := round(0.7*stringlength*font.size);
      Cells[0,0] := 'Parameter';
      Cells[1,0] := 'Parameter Name';
      Cells[2,0] := 'Parameter Value';
      Cells[3,0] := 'Parameter Units';
    end;
end;

{ TbkPageControl }

procedure TbkPageControl.DoAddDockClient(Client: TControl; const ARect: TRect);
var
  TabSheet: TbkTabSheet;
begin
  // Client cannot be added to TPageControl itself but new TabSheet should be
  // added and client placed onto it
  TabSheet := TbkTabSheet.Create(Self);
  TabSheet.Caption := GetDockCaption(Client);
  try
    TabSheet.PageControl := Self;
    Client.Parent := TabSheet;
    // delphi compatible behaviour => align to client
    Client.Align := alClient;
  except
    FreeAndNil(TabSheet);
  end;
end;

constructor TbkPageControl.Create(TheOwner: TComponent);
begin
  PageClass:=TbkTabSheet;
  inherited Create(TheOwner);
end;

end.

